web-dev-qa-db-de.com

Wie kann ich den routenselektiven Windows-VPN-Verkehr (nach Zielnetzwerk) festlegen?

Ich möchte ein Windows-VPN nur für ein bestimmtes Netzwerk verwenden, damit es nicht meine gesamte Netzwerkverbindung übernimmt.

anstatt das VPN zur Standardroute zu machen, legen Sie es nur für 192.168.123.0/24 fest

(Ich kann sehen, dass es für Ubuntu eine Lösung gibt in dieser Frage , aber manchmal muss ich das auch unter Windows tun)

Kann dies automatisiert werden, so dass dies immer dann geschieht, wenn ich eine Verbindung zum VPN herstelle?

135
Legooolas

Sie können die Übernahme Ihrer gesamten Verbindung deaktivieren, indem Sie zu den Eigenschaften von VPN, Registerkarte Networking, Eigenschaften von Internet Protocol (TCP/IP), Advanced, Use default gateway on remote network aufheben. Dies kann je nach Einrichtung des VPN-Servers eine Route zu 192.168.123.0/24 hinterlassen oder nicht. Wenn dies nicht der Fall ist, müssen Sie die Route jedes Mal manuell hinzufügen, obwohl Sie sie auch in eine Stapeldatei einfügen könnten.

Um die Route manuell hinzuzufügen, führen Sie (als Administrator) Folgendes aus:

route -p add 192.168.0.12 mask 255.255.255.255 10.100.100.254

In diesem Beispiel wird eine dauerhafte Route (der Befehl muss nach einem Neustart nicht ausgeführt werden) zum IP 192.168.0.12 über das VPN-Gateway 10.100.100.254 hergestellt.

Mehr dazu unter http://technet.Microsoft.com/en-us/library/bb878117.aspx

135
TRS-80

Ich habe die Technik von @ TRS-80 erfolgreich angewendet, um dies zu erreichen.

Ich arbeite von zu Hause aus und muss für meine E-Mails eine VPN-Verbindung zum Unternehmensnetzwerk herstellen (ich hasse Webmail !!).

Gleichzeitig muss ich ständig nach Informationen surfen und brauche auch YouTube für meine Hintergrundmusik ... Jetzt willst du definitiv kein YouTube von einem VPN streamen, da es sich so anhört wie ein Robot Singing !!! :)

Alles was ich getan habe war @ TRS-80 zu folgen:

eigenschaften von VPN, Registerkarte Netzwerk, Eigenschaften von "Internet Protocol (TCP/IP)", Erweitert, Deaktivieren Sie "Standardgateway im Remotenetzwerk verwenden".

und habe dann mein eigenes gemacht:

aktivieren Sie auf der Registerkarte DNS das Kontrollkästchen "Diese Verbindungsadressen in DNS registrieren".

Alles funktioniert nahtlos!

19
bPratik

Zugegeben, diese Antwort entspricht nicht Ihrer Anfrage, aber ich verwende ein VM speziell für diesen Zweck. Auf diese Weise wird nur das Netzwerk innerhalb von VM durch die Routen eingeschränkt.

Möglicherweise finden Sie einige bessere Antworten von anderen Personen, aber zumindest sollten Sie dies in Betracht ziehen, da dies eine einfache Lösung ist, nachdem VM erstellt wurde.

8
Wayne

Ich fand, dass es Schnittstelle im Wegbefehl direkt zeigen musste. Ohne diese Funktion wird Windows anstelle von VPN die Hauptschnittstelle der Netzwerkkarte verwenden. In meinem Fall sieht es so aus

route -p add 192.168.10.187 mask 255.255.255.255 0.0.0.0 IF 26
::           ^destination        ^mask           ^gateway   ^interface

beachte das 'IF 26'.

7
Dmitry Petrov

wenn Sie sowohl IPV4 als auch IPV6 verwenden, müssen Sie an beiden Stellen das Kontrollkästchen "Standardgateway für Remotenetzwerk verwenden" deaktivieren, auch wenn Sie nur IPV4 verwenden

4
Dave

Wenn Sie den CMAK verwenden und eine Routing-Datei einrichten, die der Client herunterladen kann, lädt Windows die Routing-Datei herunter und passt die Routen entsprechend an. Es gibt Optionen, um die Standardroute zu entfernen ... und verschiedene statische Routen & so hinzuzufügen. Dies wird übrigens als Split-Tunnel bezeichnet.

Hier gibt es eine gute Anleitung: http://blogs.technet.com/b/rrasblog/archive/2007/06/11/split-tunnelling-using-cmak.aspx

3
TheCompWiz

Ich möchte meine Lösung zum Mix hinzufügen. Es läuft auf einer Cygwin-basierten UNIX-Shell unter Windows 7 oder neuer, sollte aber auch mit MSYS2, Bash-on-Windows [WSL] nach Build 14986 oder Busybox für Windows funktionieren. Muss mit Administratorrechten ausgeführt werden.

Es hat einige Einstellungen und versucht, einige der Dinge zu erkennen, die Sie nicht explizit eingestellt haben. Außerdem wird die Schnittstellennummer (IF) explizit festgelegt, um einigen Problemen entgegenzuwirken, die einige Benutzer (wie ich) mit den anderen Lösungen hatten.

#!/bin/sh

# these three settings are required
adapter_name='VPN Connection'
username=
password=

# This setting here might be important because it's about the target network
# and in some cases it can't be properly determined automatically so this might
# be then worth setting.
# Format is in CIDR notation with the network address and a forward slash and
# the amount of network bits
target_network=192.168.0.0/24

# the IP you will get on the target network, also the VPN gateway on your
# local machine, you normally don't need to set this as the script tries to
# detect it
ip=

# optional setting for metric which normally shouldn't be necessary,
# except in te very rare cases where it should be set to a value lower than all
# other routes that might match the target network
metric=

# experimental setting to delete routes to the target network prior and after
# should normally not be needed unless this script fails and you get error
# messages like 'The route addition failed: The object already exists.'
route_cleanup=F

prog_name=${0##*/}

msg() {
  printf '%s: %s\n' "$prog_name" "$*"
}

die() {
  msg "$*" >&2
  exit 1
}

[ "$adapter_name" ] || die "Adapter name not set!"
[ "$username" ]     || die "Username not set!"
[ "$password" ]     || die "Password not set!"

if [ "$(uname -o)" != 'MS/Windows' ]; then
  id -G | grep -qE '\<0|544\>' || die 'Not running with admin rights.'
fi

msg "Disconnecting any existing connection that might exist."
rasdial.exe "$adapter_name" /d

msg "Connecting"
rasdial.exe "$adapter_name" "$username" "$password"

if [ ! "$ip" ]; then
  msg "Getting IP address on target network."
  ip=$(netsh.exe interface ip show config name="$adapter_name" |
    grep -a 'IP Address' | awk -F'[: ]+' '{print $4}')

  [ "$ip" ] || die 'Could not get IP! Exiting.'

  msg "Detected IP address as '$ip'."
fi

if [ ! "$target_network" ]; then
  msg "Getting target network."
  target_network=$(netsh.exe interface ip show config name="$adapter_name" |
    grep -a 'Subnet Prefix' | awk -F'[: ]+' '{print $4}')

  [ "$target_network" ] || die 'Could not get target network! Exiting.'

  msg "Detected target network as '$target_network'."
fi

msg "Getting VPN interface number."
if=$(ROUTE.EXE print -4 | grep -a "$adapter_name" |
  awk -F. '{gsub(" ", "");print $1}')

[ "$if" ] || die 'Could not get interface number! Exiting.'

msg "Detected VPN interface number as '$if'."

if [ "$route_cleanup" = T ]; then
  msg "Deleting any potentially already existing routes for the target network."
  ROUTE.EXE delete "$target_network"
fi

msg "Adding route for target network."
if [ "$metric" ]; then
  ROUTE.EXE add "$target_network" "$ip" IF "$if" Metric "$metric"
else
  ROUTE.EXE add "$target_network" "$ip" IF "$if"
fi

msg "VPN should be up now."
msg "Press enter to make it stop."
read -r _

if [ "$route_cleanup" = T ]; then
  msg "Deleting route."
  ROUTE.EXE delete "$target_network"
fi

msg "Disconnecting."
rasdial.exe "$adapter_name" /d

# msg "Press enter to exit."
# read -r _

exit 0

Es ist auch erwähnenswert, dass es möglicherweise erforderlich ist, manuell eine niedrige Metrik festzulegen, da sonst die Standardroute vor dem für das VPN bestimmten Datenverkehr übereinstimmt. Gehen Sie dazu zu der Adaptereinstellung, in der Sie den Menüpunkt "… Properties" für den VPN-Adapter öffnen → "Networking" tab → "Internet Protocol Version 4 (TCP/IP)" Eigenschaften → "Erweitert" → und dort deaktivieren Sie das Kontrollkästchen "Automatische Metrik" (zusätzlich zu "Standardgateway verwenden ..." natürlich) und setzen den Wert in "Schnittstellenmetrik:" Feld auf einen niedrigeren Wert als die Standardroute (siehe Ausgabe von ROUTE.EXE -4 print).

2
phk

Verwenden Sie unter Windows 8+ Add-VpnConnectionRoute cmdlet.

Add-VpnConnectionRoute -ConnectionName 'My VPN Connection' -DestinationPrefix 192.168.123.0/24
2
Der_Meister

Sie können so etwas wie netcatcher - verwenden. Fügen Sie einfach alle benötigten Routen einmal hinzu und vergessen Sie sie. Es werden automatisch Routen hinzugefügt und gelöscht, wenn Sie Ihre VPN-Sitzung verbinden oder trennen. Wenn Ihre VPN-IP-Adresse dynamisch bezogen wird (DHCP), wird sie von Netcatcher abgefangen und die Routen werden ordnungsgemäß aktualisiert.

1
Andy

aus dem russischen Forum: http://forum.ixbt.com/topic.cgi?id=14:43549

als Datei speichern (Beispiel: vpn_route.vbs) und nach dem Verbinden von vpn den Befehl ausführen

cscript vpn_route.vbs

vpn_route.vbs:

strComputer = "."
strMACAddress = "MAC of VPN interface here (example 00:45:55:00:00:00)"
strTarget = "route target here (example 192.168.123.0)"
strMask = "mask here (example 255.255.255.0)"
Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")

Set colItems = objWMIService.ExecQuery _
    ("Select * From Win32_NetworkAdapterConfiguration Where MACAddress = '" & strMACAddress & "'")
For Each objItem in colItems
strIP = objItem.IPAddress(0)
Next
Set objShell = CreateObject("WScript.Shell")
objShell.Run "route add " & strTarget & " mask " & strMask & " " & strIP
1
shibormot

Ein bisschen alt, aber ich habe einen Weg gefunden, dies mit einer anderen Maschine zu tun. Ich habe einen Laptop, auf dem ich die VPN-Verbindung einrichte, und dort habe ich FreeProxy mit Socks5 eingerichtet.

Dann richte ich Firefox auf meinem Client-Computer ein, um den Proxyserver des Laptops zu verwenden. Das Ergebnis ist, dass wenn ich Firefox oder etwas anderes verwende, das für die Verwendung dieses Socks5-Proxys eingerichtet ist, das VPN verwendet wird, andernfalls das Standardrouting.

1
Lonnie

Dies ist in Windows nicht möglich, ohne zusätzliche Programme, Batchdateien oder die Befehlszeile zu verwenden. Eine Alternative besteht darin, eine virtuelle (oder physische) Maschine zu erhalten, auf der Sie das VPN ausführen können.

Es ist merkwürdig, dass etwas so einfach zu erklären ist, wie es so schwer zu erreichen ist. Wie schwierig könnte es sein, den Datenverkehr nur von einem Programm zur VPN-Schnittstelle und alle anderen Programme zur Standardschnittstelle NIC zu leiten? Warum müssen wir dafür eine ganze virtuelle Maschine einrichten? Und mit Linux ist es möglich, aber seine Lösung ist auch nicht sehr elegant.

Es ist auch sehr gefragt: Ich bin auf Dutzende von Threads zum selben Thema gestoßen. Ich hoffe also nur, dass jemand die Lächerlichkeit davon erkennt und etwas dagegen unternimmt. (In Windows 8!)

Diese Lösung stammt aus einer nicht zugeordneten Batch-Datei . Es wurde leicht angepasst.

Anleitung für Windows 7

Das Skript stellt eine Verbindung zu Ihrem VPN her und leitet den Datenverkehr durch Ihr VPN weiter, bis ein Neustart durchgeführt wird. Sie können route add durch route -p add ersetzen, damit die Änderung bestehen bleibt. Wenn Sie jedoch keine dauerhafte IP-Adresse für Ihr VPN haben, funktioniert sie möglicherweise nicht mehr, wenn Sie Ihre VPN-IP-Adresse verwenden Änderungen.

  1. Öffnen Sie das Netzwerk- und Freigabecenter
  2. Öffnen Sie die Eigenschaften für Ihre VPN-Verbindung
  3. Klicken Sie auf die Registerkarte Networking
  4. Für IPv4 und 6:
    1. Klicken Sie auf Properties
    2. Klicken Sie auf Advanced
    3. Use default gateway[...] deaktivieren
  5. Schließen Sie alles, was in den vorherigen Schritten geöffnet wurde
  6. Bearbeiten und speichern Sie das unten stehende Stapelskript
  7. Führen Sie es als Administrator aus

Sie müssen Folgendes im Skript ersetzen:

  • <VPN> mit dem Namen der von Ihnen erstellten VPN-Verbindung
  • <USER> mit dem VPN-Benutzernamen
  • <PASS> mit dem VPN-Passwort
  • <TARGET> mit der IP-Adresse, die Sie über das VPN weiterleiten möchten (wenn Sie mehr Adressen weiterleiten möchten, duplizieren Sie einfach die drei Zeilen, in denen das Ziel verwendet wird)

Hinweis: Wenn Sie das Kennwort nicht in der Datei speichern möchten, ersetzen Sie <PASS> durch %password% und fügen Sie nach der ersten Zeile des Skripts Folgendes ein: set password= Input password:.

Skript

@echo off
@echo make sure to be disconnected!
rasdial <VPN> /d
@echo start to connect to vpn
rasdial <VPN> <USER> <PASS>
netsh interface ip show config name="<VPN>" | findstr "IP" > ip.dat
set /p ip= < ip.dat
del ip.dat
set ip=%ip:~-12%
@echo VPN IP is %ip%

set target=<TARGET>
@echo Add route for %target%
route add %target% mask 255.255.255.255 %ip%

timeout /T 3 > nul
1
Xantippe